#include <unistd.h>
#include <string.h>
#include <errno.h>
#include "wh.h"
#include "cgi.h"

static void	full_cgi_env(),
		pathinfo_env(),
		cgi_headers();

static CGI_data	*cgip = NULL;

static CGI_con_data	*cgiconp = NULL;


void
sendcgi( ip)
Request	*ip;
{
#if (! FORBID_CGI)
	FILE	*fp;

	int		fdfp,
			buflen;

	char	command[MIDLEN],
		location[MIDLEN],
		cgibuf[OUT_BUFFSIZE + 4],
		buf[BIGLEN],
		*bufptr;


	exec_ok( ip);

	location[0] = '\0';
	*ip->length = '\0';  /* Don't send length of script!! */

	
	/* RTYPE_CGI or RTYPE_NPH_CGI */
		if ( ip->filetype & WN_DIR ) {
			senderr( SERV_ERR, err_m[55], ip->filepath);
			return;
		}
		strncpy( command, ip->filepath, MIDLEN);
	
	strncpy( buf, ip->filepath, MIDLEN);

	if ( ! WN_SU_EXEC) {
		char *cp;

		if ( (cp = strrchr( buf, '/')) != NULL)
			*cp = '\0';

		if ( chdir( buf) != 0  ) {
			logerr( err_m[106], buf);
		}
	}

	cgi_env( ip, WN_FULL_CGI_SET);  /* Full CGI environment */

	if ( (inheadp->method == POST) 	&& (inheadp->tmpfile_name) 
				&& (*inheadp->tmpfile_name != '\0')) {
		strncat( command, " < ", MIDLEN);
		strncat( command, inheadp->tmpfile_name, MIDLEN);
	}

	if ( !*ip->query || (strchr( ip->query, '=') != NULL)
	     		     || ( (inheadp->method != GET) &&
			     (inheadp->method != POST)) ) {
		/* '=' in query so don't use on command line */
		if ((fp = WN_popen( command, "r")) == (FILE *) NULL ) {
			senderr( SERV_ERR, err_m[55], command);
			return;
		}
	} else { /* no '=' means its an isindex, ugh!  */
		if ( (fp = safer_popen( command, ip->query))
					== (FILE *) NULL )
			if ( (fp = WN_popen( command, "r")) 
						== (FILE *) NULL ) {
				senderr( SERV_ERR, err_m[55], command);
				return;
			}
	}

	fdfp = fileno( fp);

	if ( ip->type == RTYPE_NPH_CGI) {  /* CGI handles headers */
		ip->attributes |= WN_UNBUFFERED;  /* Don't buffer CGI */
		this_conp->keepalive = FALSE;

		send_out_fd( fdfp);

		pclose( fp);
		writelog( ip, log_m[7], ip->filepath);
		if ( inheadp->tmpfile_name && *inheadp->tmpfile_name) {
			unlink( inheadp->tmpfile_name);
			*inheadp->tmpfile_name = '\0';
		}
		return; /* to end of process_url */
	}

	/* It's a standard CGI, not an nph-CGI.  We do headers */
	cgi_headers( fp, cgibuf, location, &bufptr, &buflen);
	if ( ip->status & WN_ERROR)
		return;


	if ( !*location) {

		http_prolog( );
		ip->attributes |= WN_UNBUFFERED;  /* Don't buffer CGI */
		send_out_mem( bufptr, buflen);
		send_out_fd( fdfp);

		pclose( fp);
		writelog( ip, log_m[8], ip->filepath);
		if ( inheadp->tmpfile_name && *inheadp->tmpfile_name) {
			unlink( inheadp->tmpfile_name);
			*inheadp->tmpfile_name = '\0';
		}
		return;  /* to end of process_url */
	}
	else {
		writelog( ip, log_m[9], location);
		fmt2( ip->request, MIDLEN, log_m[12], location);
		dolocation( location, ip, 302); /* should be 303 */
		pclose( fp);
		if ( inheadp->tmpfile_name && *inheadp->tmpfile_name) {
			unlink( inheadp->tmpfile_name);
			*inheadp->tmpfile_name = '\0';
		}
		return; /* to end of process_url */
	}
#endif /* (! FORBID_CGI) */
}

void
cgi_env( ip, set_size)
Request	*ip;
int	set_size;
{
	register char	*cp;


	if ( cgip == NULL) {
		if ((cgip = (CGI_data *) malloc(sizeof (CGI_data))) == NULL ) {
			logerr( err_m[64], "cgi_env");
			return;
		}
	}

	if ( cgiconp == NULL) {
		if ((cgiconp = (CGI_con_data *) malloc(sizeof (CGI_con_data)))
		    						== NULL ) {
			logerr( err_m[64], "cgi_env");
			return;
		}
	}

	if ( ip->status & WN_FULL_CGI_SET) {
		pathinfo_env( ip);
		return;		/* CGI environment vars already set */
	}

	if ( ip->status & WN_SMALL_CGI_SET) {
		if ( set_size == WN_FULL_CGI_SET) {
			full_cgi_env( ip);
			ip->status |= WN_FULL_CGI_SET;
		}
		return;
	}

	putenv( "PATH_INFO");
	putenv( "PATH_TRANSLATED");

	bzero( (char *)cgip, sizeof( CGI_data)); 
	strncpy( cgip->method, "REQUEST_METHOD=", SMALLLEN);
	switch ( inheadp->method) {
	case GET:
		strncat( cgip->method, "GET", SMALLLEN);
		break;
	case POST:
		strncat( cgip->method, "POST", SMALLLEN);
		break;
	default:
		break;
	}
	putenv( cgip->method);

	strncpy( cgip->dirpath, "WN_DIR_PATH=", SMALLLEN);
	strncat( cgip->dirpath, ip->filepath, SMALLLEN );
	if ( (cp = strrchr( cgip->dirpath, '/')) != NULL )
		*cp = '\0';
	putenv( cgip->dirpath);

	if ( *(ip->authuser)) {
		strncpy( cgip->ruser, "REMOTE_USER=", SMALLLEN);
		strncat( cgip->ruser, ip->authuser, SMALLLEN );
		putenv( cgip->ruser);
	}

    if ( *(inheadp->host_head) ) {
		strncpy( cgip->http_myhost, "HTTP_HOST=", SMALLLEN);
		strncat( cgip->http_myhost, inheadp->host_head,
							SMALLLEN );
		putenv( cgip->http_myhost);
	}

	strncpy( cgip->lochost, "SERVER_NAME=", TINYLEN);
	strncat( cgip->lochost, hostname, SMALLLEN + TINYLEN);
	putenv( cgip->lochost);

	strncpy( cgip->dataroot2, "DOCUMENT_ROOT=", SMALLLEN);
	strncat( cgip->dataroot2, ip->rootdir, SMALLLEN );
	putenv( cgip->dataroot2);

	if ( !(this_conp->con_status & WN_CON_CGI_SET)) {
		strncpy( cgiconp->raddr, "REMOTE_ADDR=", TINYLEN);
		strncat( cgiconp->raddr, this_conp->remaddr, TINYLEN);
		putenv( cgiconp->raddr);

		fmt2( cgiconp->scheme, TINYLEN, "URL_SCHEME=",
		      this_conp->scheme);
		putenv( cgiconp->scheme);

		Snprintf1( cgiconp->lport, TINYLEN, "SERVER_PORT=%d", port);
		putenv( cgiconp->lport);

 		strncpy( cgiconp->rport, "REMOTE_PORT=", TINYLEN);
 		strncat( cgiconp->rport, this_conp->remport, TINYLEN);
 		putenv( cgiconp->rport);
 
	}

	ip->status |= WN_SMALL_CGI_SET;  /* mark small environment as setup */
	/* End of auth set of CGI variables */
	if ( (set_size == WN_FULL_CGI_SET) 
				|| (this_conp->con_status & WN_CON_CGI_SET)) {
		/* if we ever set env in this connection we must redo it */
		full_cgi_env( ip);
	}
	return;
}

static void
pathinfo_env( ip )
Request	*ip;
{
	if ( *(ip->pathinfo) && (cgip != NULL)) {
		strncpy( cgip->pathinfo, "PATH_INFO=", MIDLEN);
		strncat( cgip->pathinfo, ip->pathinfo, MIDLEN);
		putenv( cgip->pathinfo);
		strncpy( cgip->tpath, "PATH_TRANSLATED=", MIDLEN);
		strncat( cgip->tpath, ip->rootdir, MIDLEN);
		strncat( cgip->tpath,	ip->pathinfo, MIDLEN);
		putenv( cgip->tpath);
	}
}

static void
full_cgi_env( ip )
Request	*ip;
{
	char	*cp;

	pathinfo_env( ip );
	if ( !(this_conp->con_status & WN_CON_CGI_SET)) {

		this_conp->con_status |=  WN_CON_CGI_SET;

		if ( !*this_conp->remotehost )
				/* Get remote hostname if not already done */
			get_remote_info( );

		strncpy( cgiconp->rhost, "REMOTE_HOST=", TINYLEN);
		strncat( cgiconp->rhost, this_conp->remotehost, MAXHOSTNAMELEN);
		putenv( cgiconp->rhost);

		putenv("GATEWAY_INTERFACE=CGI/1.1");
	
		strncpy( cgiconp->servsoft, "SERVER_SOFTWARE=", TINYLEN);
		strncat( cgiconp->servsoft, VERSION, TINYLEN);
		putenv( cgiconp->servsoft);
}
	if ( *(ip->query)) {
		strncpy( cgip->query, "QUERY_STRING=", TINYLEN);
		strncat( cgip->query, ip->query, MIDLEN + SMALLLEN);
		putenv( cgip->query);
	}

	strncpy( cgip->serv_protocol, "SERVER_PROTOCOL=", TINYLEN);
	switch ( inheadp->protocol) {
	case HTTP0_9:
		strncat(cgip->serv_protocol, "HTTP/0.9", TINYLEN);
		break;
	case HTTP1_1:
		strncat(cgip->serv_protocol, "HTTP/1.1", TINYLEN);
		break;
	default:
		strncat( cgip->serv_protocol, "HTTP/1.0", TINYLEN);
		break;
	}

	putenv( cgip->serv_protocol);

	strncpy( cgip->scrname, "SCRIPT_NAME=", MIDLEN);
	if ( *(ip->user_dir) == '/' )
		strncat( cgip->scrname, ip->user_dir, MIDLEN );
	cp = ip->filepath + strlen( ip->rootdir);
	strncat( cgip->scrname, cp, MIDLEN );

	if ( *(cgip->scrname) )
		putenv( cgip->scrname);

	
	strncat( cgip->filescrname, ip->filepath, MIDLEN );
	putenv( cgip->filescrname);

	if ( *(inheadp->content) ) {
		strcpy( cgip->content, "CONTENT_TYPE=");
		strncat( cgip->content, inheadp->content, SMALLLEN);
		putenv( cgip->content);
	}

	if ( *(inheadp->length) ) {
		strcpy( cgip->length, "CONTENT_LENGTH=");
		strncat( cgip->length, inheadp->length, SMALLLEN);
		putenv( cgip->length);
	}

	if ( *(inheadp->accept) ) {
		strcpy( cgip->http_accept, "HTTP_ACCEPT=");
		strncat( cgip->http_accept, inheadp->accept, ACCEPTLEN);
		putenv( cgip->http_accept);
	}

	if ( *(inheadp->charset) ) {
		strcpy( cgip->http_charset, "HTTP_ACCEPT_CHARSET=");
		strncat( cgip->http_charset, inheadp->charset, ACCEPTLEN/4);
		putenv( cgip->http_charset);
	}

	if ( *(inheadp->a_encoding) ) {
		strcpy( cgip->http_encoding, "HTTP_ACCEPT_ENCODING=");
		strncat( cgip->http_encoding, 
				inheadp->a_encoding, ACCEPTLEN/4);
		putenv( cgip->http_encoding);
	}
	if ( *(inheadp->lang) ) {
		strcpy( cgip->http_lang, "HTTP_ACCEPT_LANGUAGE=");
		strncat( cgip->http_lang, inheadp->lang, ACCEPTLEN/4);
		putenv( cgip->http_lang);
	}

	if ( *(inheadp->referrer) ) {
		strcpy( cgip->http_referrer, "HTTP_REFERER=");
		strncat( cgip->http_referrer, inheadp->referrer, MIDLEN);
		putenv( cgip->http_referrer);
	}

	if ( inheadp->ua && *inheadp->ua ) {
		strcpy( cgip->http_ua, "HTTP_USER_AGENT=");
		strncat( cgip->http_ua, inheadp->ua, SMALLLEN );
		putenv( cgip->http_ua);
	}

	ip->status |= WN_FULL_CGI_SET;  /* mark environment as setup */
}

static void
cgi_headers( fp, cgibuf, location, bufptr, buflen)
FILE	*fp;
char	*cgibuf,
	*location,
	**bufptr;

int	*buflen;
{
	register char	*beginl,
			*endl,
			*cp = NULL;

	int		fd,
			n,
			m;

	fd = fileno( fp);
	while ( (n = read( fd, cgibuf, OUT_BUFFSIZE )) <= 0 ) {
		char errbuf[SMALLLEN];

		Snprintf1( errbuf, SMALLLEN, "cgi_headers: %.150s", strerror(errno));
		if ( (n == -1) && (errno == EINTR))
			continue;
		senderr( SERV_ERR, err_m[76], errbuf);
		pclose( fp);
		return;
	}

	beginl = cgibuf;
	cgibuf[n] = '\0';

	while ( TRUE) {
		if ( ( endl = strchr( beginl, '\n')) == NULL) {
			/* not all headers have been read; read more */
			n -= (beginl - cgibuf);
			mymemcpy( cgibuf, beginl, n);
			while ( (m = read( fd, cgibuf + n, OUT_BUFFSIZE - n))
								<= 0 ) {
				if ( (m == -1) && (errno == EINTR))
					continue;
				senderr( SERV_ERR, err_m[104], "");
				pclose( fp);
				return;
			}

			n += m;
			cgibuf[n] = '\0';
			beginl = cgibuf;
			continue;
		}
		if (endl > cgibuf && endl[-1] == '\r')
			endl[-1] = '\0';
		*endl++ = '\0';
		if ( *beginl == '\0' ) { 	/* blank line: end of header */
			beginl = endl;
			n -= (beginl - cgibuf);
			break;
		}

		if ( strncasecmp( "Content-type:", beginl, 13) == 0) {
			cp = beginl + 13;
			while ( isspace( *cp))
				cp++;
			strncpy( cgip->cgi_content_type, cp, SMALLLEN);
			this_rp->content_type = cgip->cgi_content_type;
		}
		else if ( (strncasecmp("Status:", beginl, 7) == 0)) {
			cp = beginl + 7;
			while ( isspace( *cp))
				cp++;
			strncpy( outheadp->status, cp, SMALLLEN);
		}
		else if ( (strncasecmp("Expires:", beginl, 8) == 0)) {
			strncpy( outheadp->expires, beginl, SMALLLEN - 2);
			strncat( outheadp->expires, "\r\n", SMALLLEN);
		}
		else {
			if (strlen(beginl) + strlen(outheadp->list) < BIGLEN - 3) {
				strncat( outheadp->list, beginl, BIGLEN);
				strncat( outheadp->list, "\r\n", BIGLEN);
			}
			else {
				senderr( SERV_ERR, err_m[56], "");
				pclose( fp);
				return;
			}

		}
		beginl = endl;
	}
	*buflen = n;
	*bufptr = endl;
}
