
#include <sys/types.h>
#include <sys/param.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <time.h>
#include <sys/time.h>

#include "../config.h"
#define	ACCEPTLEN (2048)
#define MAXDIRLEN (256)
#define NUMFIELDS (20)

#define MAXHOSTNAMELEN	(256)

#define CLIENT_ERR		"400"
#define DENYSTATUS		"404"
#define PRECON_FAILED_STATUS	"412"
#define REQ_TOO_LONG_STATUS	"413"
#define URI_TOO_LONG_STATUS	"414"
#define SERV_ERR		"500"

typedef enum { 
	RTYPE_DENIED,
	RTYPE_FILE,
	RTYPE_CGI,
	RTYPE_NPH_CGI,
} Reqtype;

typedef struct Request {
	char	request[BIGLEN],	/* The original request */
		*content_type,		/* MIME content type */
		*expires,		
		*relpath,		
		*tilde_user_group,     	/* tilde user "name gid" */
		contype[SMALLLEN],	
		rootdir[SMALLLEN],
		filepath[MIDLEN],	
		query[MIDLEN],		
		pathinfo[MIDLEN],	
		user_dir[USERNAME_LEN], /* /~username */
		length[TINYLEN];	/* File length in ASCII */
		
	FILE	*fp;

	long	datalen,		/* Length of file as a long */
		logcount;		/* Bytes sent (for log) */


	Reqtype	type;			/* RTYPE_FILE, RTYPE_CGI, etc. */

	unsigned long status;


} Request;

 Request		*this_rp;



typedef enum { 
	GET,
	POST,
	UNKNOWN
} Methodtype;

typedef enum { 
	HTTP0_9,
	HTTP1_0,
	HTTP1_1
} Prottype;

typedef struct Inheader {
	char	htext[HEADERTEXTLEN],
		*current_htext,
		accept[ACCEPTLEN],
		charset[ACCEPTLEN/4],
		lang[ACCEPTLEN/4],
		a_encoding[ACCEPTLEN/4],  /* Accept-Encoding header */
		url_path[BIGLEN],
		content[SMALLLEN],
		encoding[SMALLLEN],	/* MIME content-encoding */
		length[TINYLEN],
		referrer[MIDLEN],
		*tmpfile_name,

	Methodtype	method;
	Prottype	protocol;

	unsigned	attrib,

} Inheader;

 Inheader	*inheadp;

typedef struct Outheader {
	char	
		location[MIDLEN],
		expires[SMALLLEN],
		status[SMALLLEN];

	unsigned ohstat;
} Outheader;

Outheader	*outheadp;



typedef struct Inbuffer {
	char	buffer[INBUFFSIZE],
		*bcp;
	int	cur_sz;
} Inbuffer;


#define LOGBUFLEN	(BIGLEN + MIDLEN)
			/* must be bigger than BIGLEN+SMALLLEN */


typedef struct Connection {
	int		pid,
			more_in_buf,	/* boolean */

	char		logbuf[LOGBUFLEN],
			outbuf[OUT_BUFFSIZE + TINYLEN],
			remotehost[MAXHOSTNAMELEN],
			remaddr[20],
			remport[16],
			*out_ptr,
	long	bytecount;

	unsigned	con_status;

	Inbuffer	*bufp;
} Connection;

Connection	*this_conp;



#define streq( a, b)	( strcmp( (a), (b)) == 0 )
#define iswndir( x)	( x->filetype & WN_DIR  )
#define fmt2( b, n, s1, s2)  fmt3( b, n, s1, s2, NULL)

