#define ACCESS_DENIED		(0)
#define ACCESS_GRANTED		(1)	/* authentication may be required */
#define ACCESS_PRIVILEGED	(2)
#define ACCESS_ERR		(3)
/* for cgi */
#define CGI_BYTECHUNK	(128*1024)
typedef struct CGI_data {
char	cgi_content_type[SMALLLEN],  /* output content type */
	serv_protocol[TINYLEN],
	home[SMALLLEN],
	dataroot[SMALLLEN],
	dataroot2[SMALLLEN],
	dirpath[SMALLLEN],
	query[MIDLEN + SMALLLEN],
	pathinfo[MIDLEN],
	scrname[MIDLEN],
	http_accept[ACCEPTLEN],
	http_referrer[MIDLEN],
	http_from[SMALLLEN],
	http_myhost[SMALLLEN],
	lochost[SMALLLEN + TINYLEN],
	ruser[SMALLLEN],
	method[SMALLLEN],
	content[SMALLLEN],  /* input content type */
	length[TINYLEN];
} CGI_data;

typedef struct CGI_con_data {
char	servsoft[TINYLEN],
	rident[SMALLLEN],
	lport[TINYLEN],
	rport[TINYLEN],
	rhost[MAXHOSTNAMELEN + TINYLEN],
	raddr[2*TINYLEN];
} CGI_con_data;

/* common */
#define TRUE	(1)
#define FALSE	(0)
#define STANDARD_PORT	(80)
#define	MIDLEN		(2048)
#define	SMALLLEN	(MIDLEN/8)
#define	BIGLEN		(2*MIDLEN)
#define	HEADERTEXTLEN	(4*MIDLEN)
#define	TINYLEN		(32)
#define USERNAME_LEN	(64)
#define INBUFFSIZE	(2048)
#define OUT_BUFFSIZE	(4096)  
/* Bits in the Request attributes */
#define WN_DYNAMIC	(1<<0)
#define WN_NONDYNAMIC	(1<<1)
#define WN_POST_OK	(1<<2)
#define WN_PUT_OK	(1<<3)
#define WN_NO_POST	(1<<4)
#define	WN_NOSEARCH	(1<<6)
#define	WN_PARSE	(1<<7)
#define	WN_NOPARSE	(1<<8)
#define	WN_CGI		(1<<9)
#define WN_ISMAP	(1<<10)
#define WN_UNBUFFERED	(1<<12)
#define WN_NOKEEPALIVE	(1<<14)
#define WN_NO_GET	(1<<15)
/* Bits in the request attrib2 */
#define	WN_ISACGIBIN		(1<<5)
#define	WN_FILEMOD		(1<<6)
/* Bits in the request logtype */
#define		WN_NO_LOG		(1<<0)
#define		WN_COMMON_LOG		(1<<1)
#define		WN_VERBOSE_LOG		(1<<2)
#define		WN_NCSA_LOG		(1<<3)
#define		WN_LOG_SYSLOG		(1<<4)
#define		WN_VERBOSE_SYSLOG	(1<<5)
#define		NO_DNS_LOG		(1<<11)
#define		REV_DNS_LOG		(1<<12)

#define	IMAGE_ERR1	"Bad co-ordinates for imagemap request"
#define	IMAGE_ERR2	"No default location for imagemap"

#define TEXT_TOKEN		(0)
#define FIELD			(4)
#define IF_ERR			(7)
#define INCLUDE			(8)
#define QUERY			(9)
#define START			(11)
#define SECTION			(12)
#define TITLE			(15)
#define MATCH_ACCEPT		(16)
#define MATCH_REFERRER		(18)
#define MATCH_IP		(19)
#define MATCH_HOST		(20)
#define MATCH_QUERY		(22)
#define MATCH_REQUEST		(25)
#define MATCH_HOST_HEAD		(26)
#define MATCH_FIELD		(27)
#define ENVIRON			(28)
#define COMMENT			(29)
#define LAST_MOD_DATE		(40)

typedef struct Parsedata {
	unsigned	show;  /* see comment below */
	char		*currfile;
	int		currline;
} Parsedata;

/* tokens for pstack and sstack */

#define PS_NULL		(0)
#define PS_IF		(1)
#define PS_ELSE		(2)
#define PS_ELIF		(3)
#define PARSE_MASK	(15)		/* = 0f */
#define STATE_MASK	(15 * 16)	/* = 0f0 */
#define STACKSIZE	(64)		/* size of parse stack */

/* return values for gettoken */

#define IFCLAUSE_TERM	(1)
#define IFCLAUSE_END	(2)
#define IFCLAUSE_AND	(3)
#define IFCLAUSE_OR	(4)
#define IFCLAUSE_ERR	(5)

extern
WN_CONST 
char * WN_CONST parserr_m[];

WN_CONST
char * WN_CONST out_m[] = {
	/* 0 */ "Access denied, or file does not exist",
};

#define VERSION	"batch3Http"
#define HTTPVERSION "HTTP/1.1 "  /* need trailing space here */









