#define TRUE	(1)
#define FALSE	(0)
#include <sys/types.h>
#include <sys/param.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <time.h>
#include <sys/time.h>
#define STANDALONE	(FALSE)
extern int	WN_write(),
		WN_read();
#include "../config.h"
#define WN_write( a, b, c)		write( a, b, c)
#define WN_read( a, b, c)		read( a, b, c)
#include "globdec.h"
#define WN_HTML_MARK	"WN_mark"
#define	ACCEPTLEN (2048)
#define MAXDIRLEN (256)
#define NUMFIELDS (20)
#define FREE	(0)
#define ROOTCHK	(1)
#define DIRCHK	(2)
#define MAXHOSTNAMELEN	(256)
#define CLIENT_ERR		"400"
#define DENYSTATUS		"404"
#define PRECON_FAILED_STATUS	"412"
#define REQ_TOO_LONG_STATUS	"413"
#define URI_TOO_LONG_STATUS	"414"
#define SERV_ERR		"500"

extern FILE	*safer_popen();

extern WN_CONST
char * WN_CONST	err_m[];
extern WN_CONST
char * WN_CONST	log_m[];
extern WN_CONST
char * WN_CONST	out_m[];

extern char	rootdir[],
		wn_empty[],
		wn_tmpdir[],
		wnlogfile[],
		errlogfile[],
		pid_file[],
		hostname[],
		**mtypelist,
		*mymemcpy(),
		*get_parse_line(),
		*strlower();

extern unsigned	default_logtype,
		interface_num;

extern int	errno,
		port,
		nofork,
extern uid_t	user_id;
extern gid_t	group_id;

typedef enum {
	RTYPE_DENIED,
	RTYPE_FILE,
	RTYPE_CGI,
	RTYPE_CGI_HANDLER,
	RTYPE_PUT_HANDLER,
	RTYPE_INFO,
	RTYPE_HEAD,
	RTYPE_OPTIONS,
	RTYPE_REDIRECT,
	RTYPE_NOT_MODIFIED,
	RTYPE_FINISHED,
	RTYPE_NOACCESS,
	RTYPE_PRECON_FAILED
} Reqtype;

typedef struct Request {
	char	request[BIGLEN],	/* The original request */
			/* These are pointers into cacheline */
		*title,			/* Item title */
		*content_type,		/* MIME content type */
		*encoding,		/* MIME content-transfer-encoding */
		*handler,		/* Path to handler  */
			/* These two are pointers into filepath */
		*relpath,		/* Path rel to rootdir */
		*basename,		/* Base name of file  */

		*tilde_user_group,     	/* tilde user "name gid" */

		contype[SMALLLEN],	/* Use content_type, not this */
		rootdir[SMALLLEN],	/* Complete pathname of root dir  */
		filepath[MIDLEN],	/* Complete pathname of file  */
		query[MIDLEN],		/* Stuff after '?' in URL */
		param_field[SMALLLEN],	/* Stuff after ';' before '=' in URL */
		*param_value,		/* Stuff after '=' before '?' in URL */
		pathinfo[MIDLEN],	/* PATH_INFO for CGI */
		user_dir[USERNAME_LEN], /* /~username */
		length[TINYLEN];	/* File length in ASCII */

	FILE	*fp;
	int	fptype;			/* FP_PIPE or FP_FILE */
	long	datalen,		/* Length of file as a long */
		logcount;		/* Bytes sent (for log) */
	time_t	mod_time;		/* File modification time */
	Reqtype	type;			/* RTYPE_FILE, RTYPE_CGI, etc. */
	unsigned long	attributes,
			attrib2,
			status,
			filetype;
	} Request;

extern Request		*this_rp;


/* Bits in request allowed */
#define	WN_M_GET		(1<<0)
#define	WN_M_HEAD		(1<<1)
#define	WN_M_POST		(1<<4)
#define	WN_M_PUT		(1<<5)
#define	WN_M_DELETE		(1<<6)
#define	WN_M_MOVE		(1<<7)

/* Bits in the request status */
#define	WN_CANT_STAT		(1<<0)
#define	WN_HAS_BODY		(1<<1)
#define WN_SMALL_CGI_SET	(1<<3)
#define WN_FULL_CGI_SET		(1<<4)
#define WN_ABORTED		(1<<5)
#define WN_MATCH_SENT		(1<<6)
#define WN_ERROR		(1<<7)

/* Bits in the Request filetype */
#define	WN_TEXT			(1<<0)
#define	WN_DIR			(1<<1)
#define	WN_NOT_WORLD_READ	(1<<2)
#define	WN_NOT_REG_FILE		(1<<3)
#define	WN_DEFAULT_DOC		(1<<5)
#define	WN_WORLD_WRITABLE	(1<<10)

#define WN_CON_CGI_SET		(1<<0)
#define WN_CON_TIMEDOUT		(1<<1)


typedef struct Dir_info {
	char	dirline[BIGLEN],
		*accessfile,
		*deflist,
		*subdirs,
		*dir_owner,
		*filemod,		/* File data base  module */
		*defdoc,		/* default document for this dir */
		*default_content,	/* default content type */
		*default_charset,	/* default character set */
		*def_handler,		/* default CGI handler  */
		cantstat_url[MIDLEN/2],
		noaccess_url[MIDLEN/2];

	unsigned long	attributes,
			defattributes;
	unsigned	logtype,
	time_t		cmod_time;	/* Cache file modification time */
} Dir_info;

extern Dir_info	*dir_p;

/* Bits in the Dir attributes */

typedef enum {
	GET,
	POST,
	HEAD,
	UNKNOWN
} Methodtype;

typedef enum {
	HTTP1_0,
	HTTP1_1
} Prottype;

typedef struct Inheader {
	char	htext[HEADERTEXTLEN],
		*current_htext,
		accept[ACCEPTLEN],
		charset[ACCEPTLEN/4],
		lang[ACCEPTLEN/4],
		a_encoding[ACCEPTLEN/4],  /* Accept-Encoding header */
		url_path[BIGLEN],
		content[SMALLLEN],
		encoding[SMALLLEN],	/* MIME content-encoding */
		length[TINYLEN],
		referrer[MIDLEN],
		from[SMALLLEN],
		host_head[SMALLLEN],
		*new_uri,
		new_uri_env[MIDLEN/2],
	
	Methodtype	method;
	Prottype	protocol;

	unsigned	attrib,conget;
	

} Inheader;

extern Inheader	*inheadp;


/* Bits in inheadp->conget */

#define	IFNMATCH	(1<<0)
#define	IFMATCH		(1<<1)






typedef struct Outheader {
	char
		list[BIGLEN],
		location[MIDLEN],
		status[SMALLLEN];

	unsigned ohstat;
} Outheader;
extern Outheader	*outheadp;
/* Bits in outheadp->ohstat */
#define	OHSTAT_ISREDIR	(1)
typedef struct Inbuffer {
	char	buffer[INBUFFSIZE],
		*bcp;
	int	cur_sz;
} Inbuffer;


#define LOGBUFLEN	(BIGLEN + MIDLEN)
			/* must be bigger than BIGLEN+SMALLLEN */


typedef struct Connection {
	int		pid,
		t	keepalive,	/* boolean */
	char		logbuf[LOGBUFLEN],
			outbuf[OUT_BUFFSIZE + TINYLEN],
			remotehost[MAXHOSTNAMELEN],
			remaddr[20],
			remport[16],
	long		bytecount;
	unsigned	con_status,
	Inbuffer	*bufp;
} Connection;
extern Connection	*this_conp;
